section .rodata
	prompt1 db "Enter a number:",0
	prompt2 db "Enter another number:",0
	prompt3 db "The greater of %ld and %ld is %ld.",10,0
	num_format db "%ld",0


section .text
	global main
	extern printf, scanf 

	main:
		; prologue
		push	rbp
		mov		rbp, rsp
		sub		rsp, 16			;we read in two long integers on the stack
		push	rbx
		push	r12
		push	r13
		push	r14
		push	r15
		pushfq

		; read in input1
		mov		rdi, dword prompt1
		xor		rax, rax
		call	printf
		lea		rsi, [rbp-8]
		mov		rdi, dword num_format
		xor		rax, rax
		call	scanf

		; read in input2
		mov		rdi, dword prompt2
		xor		rax, rax
		call	printf
		lea 	rsi, [rbp-16]
		mov		rdi, dword num_format
		xor		rax, rax
		call	scanf
	

		; is input2 > input1 ?
		xor		rbx, rbx
		mov		rax, [rbp-16]				; place input2 in rax
		cmp		rax, [rbp-8]				; is input2 > input1 ?
		setg	bl 							; rbx = input2 > input1 ? 1 : 0	
		neg		rbx							; rbx = input2 > input1 ? 0xFFFFFFFFFFFFFFFF : 0x0
		mov		rcx, rbx					; rcx = input2 > input1 ? 0xFFFFFFFFFFFFFFFF : 0x0
		and		rcx, [rbp-16]				; rcx = (input2 > input1 ? 0xFFFFFFFFFFFFFFFF: 0x0) && input2 ? input2 : 0x0
		not		rbx							; rbx = input2 > input1 ? 0x0 : 0xFFFFFFFFFFFFFFFF
		and		rbx, [rbp-8]				; rbx = (input2 > input1 ? 0x0 : 0xFFFFFFFFFFFFFFFF) && input1 ? 0x0 : input1
		or 		rcx, rbx					; rcx = input2 > input1 ? input2 || 0x0 : 0x0 || input1 = input2 : input1
		
		; RCX contains the greater value
		mov		rdx, [rbp-16]
		mov		rsi, [rbp-8]
		mov		rdi, dword prompt3
		xor		rax, rax
		call	printf

		; epilogue
		popfq
		pop		r15
		pop		r14
		pop		r13
		pop		r12
		pop		rbx
		add		rsp, 16
		leave
		ret
		   
